//+------------------------------------------------------------------+
//|                                           Middle_Order_Price.mq4 |
//|                                                         StSpirit |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "StSpirit"
#property link      ""

#property indicator_chart_window

extern color LineColor = Magenta;              // 
extern int LineWidth = 2;                      // 

extern bool Text_With_Line = true;             //     
extern string Text="Middle Order Price";       //   
extern color TextColor = Violet;               //    
extern int FontSize = 8;                       //    

string LineName = "Middle_Order_Price";        // 
string TextName = "Text_MOP";                  //   


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
//----
   return(0);
  }
  
  void OrderMiddleLine(string Name, double Value)
   {
   string objectName = Name;
   if(ObjectFind("Middle_Order_Price")!=0)//   
      {
   ObjectCreate(objectName, OBJ_HLINE, 0, 0, Value);
   ObjectSet(objectName, OBJPROP_COLOR, LineColor);
   ObjectSet(objectName, OBJPROP_WIDTH, LineWidth);
   ObjectSet(objectName, OBJPROP_BACK, true);
      }
   else  //  ,  
      {
      ObjectMove(objectName, 0, Time[0],Value);
      }
   return(0);
  }

    void LineText(string Name, double MOP)
   {
   string objectName = Name;
   if(ObjectFind("Text_MOP")!=0)//   
      {
      ObjectCreate(objectName, OBJ_TEXT, 0, Time[5],MOP);
      ObjectSetText(objectName, Text, FontSize, "Arial", TextColor); //  
      ObjectSet(objectName, OBJPROP_BACK, true);
      }
   else  //  ,  
      {
      ObjectMove(objectName, 0, Time[5],MOP);
      }
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectDelete(LineName);
   ObjectDelete(TextName);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  double a=0, b=0, price_ask=0, price_bid=0;
//----

   if (OrdersTotal()!=0)
      {
      for (int i = 0; i < OrdersTotal(); i++)
         {
         if (OrderSelect(i, SELECT_BY_POS)==true)
            {
            if (OrderSymbol() == Symbol())
               {
               if (OrderType() == OP_BUY)
                  {
                  price_ask = price_ask + OrderOpenPrice() * OrderLots();
                  a = a + OrderLots();
                  }
            
               if (OrderType() == OP_SELL)
                  {
                  price_bid = price_bid + OrderOpenPrice() * OrderLots();
                  b = b + OrderLots();
                  }
               }
            }
         }
      if (a==0 && b==0)
         {
         ObjectDelete(LineName);
         ObjectDelete(TextName);       
         }
      if (a != 0)
         {
         Comment("AVERAGE"," BUY = ",a," : ",DoubleToStr(price_ask/a,6));
         OrderMiddleLine(LineName, price_ask/a);
         if (Text_With_Line!=false) LineText(TextName, price_ask/a);
         a=0;
         price_ask=0;
         }
      if (b != 0)
         {
         Comment("AVERAGE"," SELL = ",b," : ", DoubleToStr(price_bid/b,6));
         OrderMiddleLine(LineName, price_bid/b);
         if (Text_With_Line!=false) LineText(TextName, price_bid/b);
         b=0;
         price_bid=0;
         }

  }

//----
   return(0);
  }
//+------------------------------------------------------------------+